(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('ngx-mat-select'), require('ngx-filters'), require('@angular/material/slide-toggle'), require('@angular/material/select'), require('@angular/material/form-field'), require('@angular/material/input'), require('@angular/forms'), require('@angular/material/datepicker'), require('@angular/material/dialog')) :
    typeof define === 'function' && define.amd ? define('ngx-mat-filters', ['exports', '@angular/core', '@angular/common', 'ngx-mat-select', 'ngx-filters', '@angular/material/slide-toggle', '@angular/material/select', '@angular/material/form-field', '@angular/material/input', '@angular/forms', '@angular/material/datepicker', '@angular/material/dialog'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-mat-filters'] = {}, global.ng.core, global.ng.common, global.ngxMatSelect, global.ngxFilters, global.ng.material.slideToggle, global.ng.material.select, global.ng.material.formField, global.ng.material.input, global.ng.forms, global.ng.material.datepicker, global.ng.material.dialog));
}(this, (function (exports, i0, common, ngxMatSelect, ngxFilters, slideToggle, select, formField, input, forms, datepicker, dialog) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var MatConditionsSelectorComponent = /** @class */ (function (_super) {
        __extends(MatConditionsSelectorComponent, _super);
        function MatConditionsSelectorComponent(injector) {
            var _this = _super.call(this) || this;
            _this.conditions = [];
            _this.valueChange = new i0.EventEmitter();
            return _this;
        }
        MatConditionsSelectorComponent.prototype.ngOnInit = function () {
        };
        MatConditionsSelectorComponent.prototype.onValueChange = function (ev) {
            this.valueChange.emit(ev);
        };
        return MatConditionsSelectorComponent;
    }(ngxFilters.NgxConditionSelectorFilter));
    MatConditionsSelectorComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'conditions-selector',
                    template: "<mat-form-field *ngIf=\"filter\" style=\";margin-bottom: 6px;max-width: 200px\">\n  <mat-select [title]=\"label\" #sf=\"ngxMatSelect\"\n              [disabled]=\"filter.disabledCondition\"\n              [source]=\"conditions\"\n              ngxMatSelect\n              mobileViewType=\"BottomSheet\"\n              [hasSearchBox]=\"false\"\n              (valueChange)=\"onValueChange($event)\"\n              [(value)]=\"filter.conditionOperator\">\n    <mat-option *ngFor=\"let condition of sf.filteredSource\" [value]=\"condition.key\">\n      {{condition.label}}\n    </mat-option>\n  </mat-select>\n</mat-form-field>\n",
                    styles: [".conditions-selector-container{display:flex}", ".ngx-mat-filters-wrapper{min-height:100px;padding:20px 2px;position:relative}.ngx-mat-filter-item{display:flex;grid-gap:10px;grid-template-columns:120px auto;max-width:550px;position:relative}.ngx-mat-filter-item-display-label{font-size:1.1rem;margin-right:5px;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.ngx-mat-filters-wrapper .mat-expansion-panel-header{max-width:100%;padding:0 5px!important}.ngx-mat-filters-wrapper mat-form-field{max-width:100%}.ngx-mat-filter-items.xs .mat-expansion-panel-body{padding:0!important}ngx-mat-filters-list mat-form-field{flex:1}ngx-mat-filters-list .mat-form-field-wrapper{margin:0;padding:0}ngx-mat-filters-list .mat-expansion-panel{width:100%}ngx-mat-filters-list .filter-true-false,ngx-mat-filters-list .mat-expansion-panel{border-bottom:1px dashed #bdbdbd;box-shadow:none!important}.filters-component-wrapper{display:flex;flex-wrap:wrap;grid-gap:8px;width:100%}@media (max-width:400px){.ngx-mat-filter-item{grid-gap:0;grid-template-columns:auto}}.filter-true-false{align-items:center;display:flex;justify-content:space-between;width:100%}.ngx-mat-filters-header{height:42px!important}.filters-component-true-false-wrapper{display:flex;justify-content:flex-end;margin-left:8px}.filter-header{align-items:center;display:flex;width:100%}.filter-spinner,.filter-spinner-container{left:50%;position:absolute;top:50%;transform:translate(-50%,-50%)}.filter-spinner{z-index:2}.filter-text-success{color:#689f38;height:12px;left:1px;position:absolute;top:15px}"]
                },] }
    ];
    MatConditionsSelectorComponent.ctorParameters = function () { return [
        { type: i0.Injector }
    ]; };
    MatConditionsSelectorComponent.propDecorators = {
        conditions: [{ type: i0.Input }],
        filter: [{ type: i0.Input }]
    };

    var DateTimeFilterComponent = /** @class */ (function (_super) {
        __extends(DateTimeFilterComponent, _super);
        function DateTimeFilterComponent(injector) {
            var _this = _super.call(this) || this;
            _this.startDate = new Date();
            _this.valueChange = new i0.EventEmitter();
            return _this;
        }
        DateTimeFilterComponent.prototype.ngOnInit = function () {
        };
        DateTimeFilterComponent.prototype.onValueChange = function (ev) {
            this.valueChange.emit(new Date(ev));
        };
        DateTimeFilterComponent.prototype.onConditionChange = function () {
        };
        return DateTimeFilterComponent;
    }(ngxFilters.NgxDateFilter));
    DateTimeFilterComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'date-time-filter',
                    template: "<mat-form-field\n>\n  <mat-label>\n    {{label}}\n  </mat-label>\n  <input\n    autocomplete=\"off\"\n    [(ngModel)]=\"value\"\n    disabled\n    (ngModelChange)=\"onValueChange($event)\"\n    matInput [matDatepicker]=\"picker\">\n  <mat-datepicker-toggle matSuffix [for]=\"picker\"></mat-datepicker-toggle>\n  <mat-datepicker disabled=\"false\" #picker></mat-datepicker>\n</mat-form-field>\n\n\n",
                    styles: ["", ".ngx-mat-filters-wrapper{min-height:100px;padding:20px 2px;position:relative}.ngx-mat-filter-item{display:flex;grid-gap:10px;grid-template-columns:120px auto;max-width:550px;position:relative}.ngx-mat-filter-item-display-label{font-size:1.1rem;margin-right:5px;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.ngx-mat-filters-wrapper .mat-expansion-panel-header{max-width:100%;padding:0 5px!important}.ngx-mat-filters-wrapper mat-form-field{max-width:100%}.ngx-mat-filter-items.xs .mat-expansion-panel-body{padding:0!important}ngx-mat-filters-list mat-form-field{flex:1}ngx-mat-filters-list .mat-form-field-wrapper{margin:0;padding:0}ngx-mat-filters-list .mat-expansion-panel{width:100%}ngx-mat-filters-list .filter-true-false,ngx-mat-filters-list .mat-expansion-panel{border-bottom:1px dashed #bdbdbd;box-shadow:none!important}.filters-component-wrapper{display:flex;flex-wrap:wrap;grid-gap:8px;width:100%}@media (max-width:400px){.ngx-mat-filter-item{grid-gap:0;grid-template-columns:auto}}.filter-true-false{align-items:center;display:flex;justify-content:space-between;width:100%}.ngx-mat-filters-header{height:42px!important}.filters-component-true-false-wrapper{display:flex;justify-content:flex-end;margin-left:8px}.filter-header{align-items:center;display:flex;width:100%}.filter-spinner,.filter-spinner-container{left:50%;position:absolute;top:50%;transform:translate(-50%,-50%)}.filter-spinner{z-index:2}.filter-text-success{color:#689f38;height:12px;left:1px;position:absolute;top:15px}"]
                },] }
    ];
    DateTimeFilterComponent.ctorParameters = function () { return [
        { type: i0.Injector }
    ]; };
    DateTimeFilterComponent.propDecorators = {
        filter: [{ type: i0.Input }]
    };

    var NumberBoxFilterComponent = /** @class */ (function (_super) {
        __extends(NumberBoxFilterComponent, _super);
        function NumberBoxFilterComponent(injector) {
            var _this = _super.call(this) || this;
            _this.valueChange = new i0.EventEmitter();
            return _this;
        }
        NumberBoxFilterComponent.prototype.ngOnInit = function () {
        };
        return NumberBoxFilterComponent;
    }(ngxFilters.NgxNumberBoxFilter));
    NumberBoxFilterComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'number-box-filter',
                    template: "<div class=\"filters-component-wrapper\">\n  <mat-form-field>\n    <mat-label>\n      {{label}}\n    </mat-label>\n    <input (ngModelChange)=\" valueChange.emit($event); filter? filter.valueName = $event: ''\"\n           autocomplete=\"off\" type=\"number\" matInput\n           [(ngModel)]=\"value\">\n    <mat-hint\n      *ngIf=\"isMoney\">{{value | separateThreeComma}}\n      {{prefixTextForHint}}</mat-hint>\n\n  </mat-form-field>\n</div>\n\n",
                    styles: ["", ".ngx-mat-filters-wrapper{min-height:100px;padding:20px 2px;position:relative}.ngx-mat-filter-item{display:flex;grid-gap:10px;grid-template-columns:120px auto;max-width:550px;position:relative}.ngx-mat-filter-item-display-label{font-size:1.1rem;margin-right:5px;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.ngx-mat-filters-wrapper .mat-expansion-panel-header{max-width:100%;padding:0 5px!important}.ngx-mat-filters-wrapper mat-form-field{max-width:100%}.ngx-mat-filter-items.xs .mat-expansion-panel-body{padding:0!important}ngx-mat-filters-list mat-form-field{flex:1}ngx-mat-filters-list .mat-form-field-wrapper{margin:0;padding:0}ngx-mat-filters-list .mat-expansion-panel{width:100%}ngx-mat-filters-list .filter-true-false,ngx-mat-filters-list .mat-expansion-panel{border-bottom:1px dashed #bdbdbd;box-shadow:none!important}.filters-component-wrapper{display:flex;flex-wrap:wrap;grid-gap:8px;width:100%}@media (max-width:400px){.ngx-mat-filter-item{grid-gap:0;grid-template-columns:auto}}.filter-true-false{align-items:center;display:flex;justify-content:space-between;width:100%}.ngx-mat-filters-header{height:42px!important}.filters-component-true-false-wrapper{display:flex;justify-content:flex-end;margin-left:8px}.filter-header{align-items:center;display:flex;width:100%}.filter-spinner,.filter-spinner-container{left:50%;position:absolute;top:50%;transform:translate(-50%,-50%)}.filter-spinner{z-index:2}.filter-text-success{color:#689f38;height:12px;left:1px;position:absolute;top:15px}"]
                },] }
    ];
    NumberBoxFilterComponent.ctorParameters = function () { return [
        { type: i0.Injector }
    ]; };
    NumberBoxFilterComponent.propDecorators = {
        filter: [{ type: i0.Input }]
    };

    var MatSelectBase = /** @class */ (function (_super) {
        __extends(MatSelectBase, _super);
        function MatSelectBase(injector) {
            var _this = _super.call(this) || this;
            _this.valueChange = new i0.EventEmitter();
            _this.selectBoxConfigs = injector.get(ngxMatSelect.NGX_MAT_SELECT_CONFIGS, null);
            return _this;
        }
        MatSelectBase.prototype.ngAfterViewInit = function () {
            // setTimeout(() => {
            //   if (this.inFirstLoadCallSearcher) {
            //     setTimeout(() => {
            //       this.sf?.refreshData();
            //     }, 20);
            //   }
            // }, 50);
            _super.prototype.ngAfterViewInit.call(this);
        };
        MatSelectBase.prototype.ngOnInit = function () {
            // if (this.filter && this.filter.options) {
            //   const option = this.filter?.options?.selectBoxOptions;
            //   if (this.selectBoxConfigs) {
            //     if (option) {
            //       this.filter.options.selectBoxOptions = Object.assign(this.selectBoxConfigs, this.filter.options.selectBoxOptions);
            //     } else {
            //       this.filter.options.selectBoxOptions = Object.assign(new FilterSelectBoxOptions(), this.selectBoxConfigs);
            //     }
            //   }
            // }
        };
        return MatSelectBase;
    }(ngxFilters.NgxSelectBoxFilter));
    MatSelectBase.decorators = [
        { type: i0.Directive, args: [{},] }
    ];
    MatSelectBase.ctorParameters = function () { return [
        { type: i0.Injector }
    ]; };
    MatSelectBase.propDecorators = {
        sf: [{ type: i0.ViewChild, args: ['sf',] }]
    };

    var SelectBoxFilterComponent = /** @class */ (function (_super) {
        __extends(SelectBoxFilterComponent, _super);
        function SelectBoxFilterComponent(injector) {
            var _this = _super.call(this, injector) || this;
            _this.injector = injector;
            _this.valueChange = new i0.EventEmitter();
            return _this;
        }
        SelectBoxFilterComponent.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
        };
        SelectBoxFilterComponent.prototype.ngOnInit = function () {
            _super.prototype.ngOnInit.call(this);
        };
        return SelectBoxFilterComponent;
    }(MatSelectBase));
    SelectBoxFilterComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'select-box-filter',
                    template: "<div class=\"ngx-filters-component-wrapper\">\n  <mat-form-field>\n    <mat-select\n      [multiple]=\"false\"\n      ngxMatSelect\n      [(ngModel)]=\"value\"\n      (ngModelChange)=\"valueChange.emit($event)\"\n      [lazyLoad]=\"lazyLoad\"\n      [displayMember]=\"displayMember\"\n      [valueMember]=\"valueMember\"\n      [searcher]=\"searcher\"\n      [source]=\"options?.source\"\n      (filteredSourceChange)=\"filterSourceChange($event)\"\n      [searchBoxPlaceholder]=\"placeholder\"\n      [useMobileView]=\"useMobileView\"\n      [emptyLabel]=\"emptyText\"\n      [mobileViewType]=\"mobileViewType\"\n      [maximumResultForShow]=\"maximumResultForShow\"\n      [hasSearchBox]=\"hasSearch\"\n      [useInfiniteScroll]=\"useInfiniteScroll\"\n      [noMoreResultLabel]=\"noMoreResultLabel\"\n      [inFirstLoadCallSearcher]=\"inFirstLoadCallSearcher\"\n      [inFirstLoadSearcherValue]=\"inFirstLoadSearcherValue\"\n      #sf=\"ngxMatSelect\"\n    >\n      <mat-option [value]=\"val\"\n                  *ngFor=\"let val of sf?.filteredSource\">\n        <span [innerHTML]=\"val[displayMember]\"></span>\n      </mat-option>\n    </mat-select>\n  </mat-form-field>\n\n\n</div>\n",
                    styles: ["", ".ngx-mat-filters-wrapper{min-height:100px;padding:20px 2px;position:relative}.ngx-mat-filter-item{display:flex;grid-gap:10px;grid-template-columns:120px auto;max-width:550px;position:relative}.ngx-mat-filter-item-display-label{font-size:1.1rem;margin-right:5px;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.ngx-mat-filters-wrapper .mat-expansion-panel-header{max-width:100%;padding:0 5px!important}.ngx-mat-filters-wrapper mat-form-field{max-width:100%}.ngx-mat-filter-items.xs .mat-expansion-panel-body{padding:0!important}ngx-mat-filters-list mat-form-field{flex:1}ngx-mat-filters-list .mat-form-field-wrapper{margin:0;padding:0}ngx-mat-filters-list .mat-expansion-panel{width:100%}ngx-mat-filters-list .filter-true-false,ngx-mat-filters-list .mat-expansion-panel{border-bottom:1px dashed #bdbdbd;box-shadow:none!important}.filters-component-wrapper{display:flex;flex-wrap:wrap;grid-gap:8px;width:100%}@media (max-width:400px){.ngx-mat-filter-item{grid-gap:0;grid-template-columns:auto}}.filter-true-false{align-items:center;display:flex;justify-content:space-between;width:100%}.ngx-mat-filters-header{height:42px!important}.filters-component-true-false-wrapper{display:flex;justify-content:flex-end;margin-left:8px}.filter-header{align-items:center;display:flex;width:100%}.filter-spinner,.filter-spinner-container{left:50%;position:absolute;top:50%;transform:translate(-50%,-50%)}.filter-spinner{z-index:2}.filter-text-success{color:#689f38;height:12px;left:1px;position:absolute;top:15px}"]
                },] }
    ];
    SelectBoxFilterComponent.ctorParameters = function () { return [
        { type: i0.Injector }
    ]; };
    SelectBoxFilterComponent.propDecorators = {
        filter: [{ type: i0.Input }]
    };

    var TrueFalseFilterComponent = /** @class */ (function (_super) {
        __extends(TrueFalseFilterComponent, _super);
        function TrueFalseFilterComponent(injector) {
            var _this = _super.call(this) || this;
            _this.valueChange = new i0.EventEmitter();
            return _this;
        }
        TrueFalseFilterComponent.prototype.ngOnInit = function () {
        };
        TrueFalseFilterComponent.prototype.onChangeValue = function (ev) {
            var _a;
            !ev ? ((_a = this.options) === null || _a === void 0 ? void 0 : _a.falseIsNull) ?
                this.value = null : this.value = false :
                this.value = ev;
            this.valueChange.emit(this.value);
        };
        return TrueFalseFilterComponent;
    }(ngxFilters.NgxTrueFalseFilter));
    TrueFalseFilterComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'true-false-filter',
                    template: "<div class=\"filters-component-true-false-wrapper\">\n\n    <mat-slide-toggle (click)=\"$event.stopPropagation()\"\n                      (ngModelChange)\n                              =\"onChangeValue($event)\"\n                      #toggle [ngModel]=\"value\">\n        {{filter.value | trueFalseFilter:filter.options}}\n    </mat-slide-toggle>\n</div>\n",
                    exportAs: 'trueFalseFilter',
                    styles: ["", ".ngx-mat-filters-wrapper{min-height:100px;padding:20px 2px;position:relative}.ngx-mat-filter-item{display:flex;grid-gap:10px;grid-template-columns:120px auto;max-width:550px;position:relative}.ngx-mat-filter-item-display-label{font-size:1.1rem;margin-right:5px;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.ngx-mat-filters-wrapper .mat-expansion-panel-header{max-width:100%;padding:0 5px!important}.ngx-mat-filters-wrapper mat-form-field{max-width:100%}.ngx-mat-filter-items.xs .mat-expansion-panel-body{padding:0!important}ngx-mat-filters-list mat-form-field{flex:1}ngx-mat-filters-list .mat-form-field-wrapper{margin:0;padding:0}ngx-mat-filters-list .mat-expansion-panel{width:100%}ngx-mat-filters-list .filter-true-false,ngx-mat-filters-list .mat-expansion-panel{border-bottom:1px dashed #bdbdbd;box-shadow:none!important}.filters-component-wrapper{display:flex;flex-wrap:wrap;grid-gap:8px;width:100%}@media (max-width:400px){.ngx-mat-filter-item{grid-gap:0;grid-template-columns:auto}}.filter-true-false{align-items:center;display:flex;justify-content:space-between;width:100%}.ngx-mat-filters-header{height:42px!important}.filters-component-true-false-wrapper{display:flex;justify-content:flex-end;margin-left:8px}.filter-header{align-items:center;display:flex;width:100%}.filter-spinner,.filter-spinner-container{left:50%;position:absolute;top:50%;transform:translate(-50%,-50%)}.filter-spinner{z-index:2}.filter-text-success{color:#689f38;height:12px;left:1px;position:absolute;top:15px}"]
                },] }
    ];
    TrueFalseFilterComponent.ctorParameters = function () { return [
        { type: i0.Injector }
    ]; };
    TrueFalseFilterComponent.propDecorators = {
        filter: [{ type: i0.Input }],
        slideToggle: [{ type: i0.ViewChild, args: [slideToggle.MatSlideToggle,] }]
    };

    var MultiSelectBoxFilterComponent = /** @class */ (function (_super) {
        __extends(MultiSelectBoxFilterComponent, _super);
        function MultiSelectBoxFilterComponent(injector) {
            var _this = _super.call(this, injector) || this;
            _this.injector = injector;
            _this.valueChange = new i0.EventEmitter();
            return _this;
        }
        MultiSelectBoxFilterComponent.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
        };
        MultiSelectBoxFilterComponent.prototype.ngOnInit = function () {
            _super.prototype.ngOnInit.call(this);
        };
        return MultiSelectBoxFilterComponent;
    }(MatSelectBase));
    MultiSelectBoxFilterComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'multi-select-box-filter',
                    template: "<div class=\"ngx-filters-component-wrapper\">\n  <mat-form-field>\n    <mat-select\n      [multiple]=\"true\"\n      ngxMatSelect\n      [(ngModel)]=\"value\"\n      (ngModelChange)=\"valueChange.emit($event)\"\n      [lazyLoad]=\"lazyLoad\"\n      [displayMember]=\"displayMember\"\n      [valueMember]=\"valueMember\"\n      [searcher]=\"searcher\"\n      [source]=\"options?.source\"\n      (filteredSourceChange)=\"filterSourceChange($event)\"\n      [searchBoxPlaceholder]=\"placeholder\"\n      [useMobileView]=\"useMobileView\"\n      [emptyLabel]=\"emptyText\"\n      [mobileViewType]=\"mobileViewType\"\n      [maximumResultForShow]=\"maximumResultForShow\"\n      [hasSearchBox]=\"hasSearch\"\n      [useInfiniteScroll]=\"useInfiniteScroll\"\n      [noMoreResultLabel]=\"noMoreResultLabel\"\n      [inFirstLoadCallSearcher]=\"inFirstLoadCallSearcher\"\n      [inFirstLoadSearcherValue]=\"inFirstLoadSearcherValue\"\n\n      #sf=\"ngxMatSelect\"\n    >\n      <mat-option [value]=\"val\"\n                  *ngFor=\"let val of sf?.filteredSource\">\n        <span [innerHTML]=\"val[displayMember]\"></span>\n      </mat-option>\n    </mat-select>\n\n  </mat-form-field>\n\n\n</div>\n",
                    styles: [".ngx-mat-filters-wrapper{min-height:100px;padding:20px 2px;position:relative}.ngx-mat-filter-item{display:flex;grid-gap:10px;grid-template-columns:120px auto;max-width:550px;position:relative}.ngx-mat-filter-item-display-label{font-size:1.1rem;margin-right:5px;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.ngx-mat-filters-wrapper .mat-expansion-panel-header{max-width:100%;padding:0 5px!important}.ngx-mat-filters-wrapper mat-form-field{max-width:100%}.ngx-mat-filter-items.xs .mat-expansion-panel-body{padding:0!important}ngx-mat-filters-list mat-form-field{flex:1}ngx-mat-filters-list .mat-form-field-wrapper{margin:0;padding:0}ngx-mat-filters-list .mat-expansion-panel{width:100%}ngx-mat-filters-list .filter-true-false,ngx-mat-filters-list .mat-expansion-panel{border-bottom:1px dashed #bdbdbd;box-shadow:none!important}.filters-component-wrapper{display:flex;flex-wrap:wrap;grid-gap:8px;width:100%}@media (max-width:400px){.ngx-mat-filter-item{grid-gap:0;grid-template-columns:auto}}.filter-true-false{align-items:center;display:flex;justify-content:space-between;width:100%}.ngx-mat-filters-header{height:42px!important}.filters-component-true-false-wrapper{display:flex;justify-content:flex-end;margin-left:8px}.filter-header{align-items:center;display:flex;width:100%}.filter-spinner,.filter-spinner-container{left:50%;position:absolute;top:50%;transform:translate(-50%,-50%)}.filter-spinner{z-index:2}.filter-text-success{color:#689f38;height:12px;left:1px;position:absolute;top:15px}"]
                },] }
    ];
    MultiSelectBoxFilterComponent.ctorParameters = function () { return [
        { type: i0.Injector }
    ]; };
    MultiSelectBoxFilterComponent.propDecorators = {
        filter: [{ type: i0.Input }]
    };

    var TextBoxFilterComponent = /** @class */ (function (_super) {
        __extends(TextBoxFilterComponent, _super);
        function TextBoxFilterComponent(injector) {
            var _this = _super.call(this) || this;
            _this.valueChange = new i0.EventEmitter();
            return _this;
        }
        TextBoxFilterComponent.prototype.ngOnInit = function () {
        };
        return TextBoxFilterComponent;
    }(ngxFilters.NgxTextBoxFilter));
    TextBoxFilterComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'text-box-filter',
                    template: "<div class=\"ngx-filters-component-wrapper\">\n  <mat-form-field>\n    <mat-label></mat-label>\n    <input type=\"text\" matInput [(ngModel)]=\"value\" (ngModelChange)=\"valueChange.emit($event)\">\n  </mat-form-field>\n</div>\n",
                    styles: [".ngx-mat-filters-wrapper{min-height:100px;padding:20px 2px;position:relative}.ngx-mat-filter-item{display:flex;grid-gap:10px;grid-template-columns:120px auto;max-width:550px;position:relative}.ngx-mat-filter-item-display-label{font-size:1.1rem;margin-right:5px;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.ngx-mat-filters-wrapper .mat-expansion-panel-header{max-width:100%;padding:0 5px!important}.ngx-mat-filters-wrapper mat-form-field{max-width:100%}.ngx-mat-filter-items.xs .mat-expansion-panel-body{padding:0!important}ngx-mat-filters-list mat-form-field{flex:1}ngx-mat-filters-list .mat-form-field-wrapper{margin:0;padding:0}ngx-mat-filters-list .mat-expansion-panel{width:100%}ngx-mat-filters-list .filter-true-false,ngx-mat-filters-list .mat-expansion-panel{border-bottom:1px dashed #bdbdbd;box-shadow:none!important}.filters-component-wrapper{display:flex;flex-wrap:wrap;grid-gap:8px;width:100%}@media (max-width:400px){.ngx-mat-filter-item{grid-gap:0;grid-template-columns:auto}}.filter-true-false{align-items:center;display:flex;justify-content:space-between;width:100%}.ngx-mat-filters-header{height:42px!important}.filters-component-true-false-wrapper{display:flex;justify-content:flex-end;margin-left:8px}.filter-header{align-items:center;display:flex;width:100%}.filter-spinner,.filter-spinner-container{left:50%;position:absolute;top:50%;transform:translate(-50%,-50%)}.filter-spinner{z-index:2}.filter-text-success{color:#689f38;height:12px;left:1px;position:absolute;top:15px}"]
                },] }
    ];
    TextBoxFilterComponent.ctorParameters = function () { return [
        { type: i0.Injector }
    ]; };

    var TrueFalseFilterPipe = /** @class */ (function () {
        function TrueFalseFilterPipe() {
        }
        TrueFalseFilterPipe.prototype.transform = function (value) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            var _a, _b;
            var options = args[0];
            var trueLabel = ((_a = options === null || options === void 0 ? void 0 : options.trueFalseOptions) === null || _a === void 0 ? void 0 : _a.trueLabel) ? options.trueFalseOptions.trueLabel : 'Yes';
            var falseLabel = ((_b = options === null || options === void 0 ? void 0 : options.trueFalseOptions) === null || _b === void 0 ? void 0 : _b.falseLabel) ? options.trueFalseOptions.falseLabel : 'No';
            if (value === true) {
                return trueLabel;
            }
            return falseLabel;
        };
        return TrueFalseFilterPipe;
    }());
    TrueFalseFilterPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'trueFalseFilter'
                },] }
    ];

    var SeparateThreeCommaPipe = /** @class */ (function () {
        function SeparateThreeCommaPipe() {
        }
        SeparateThreeCommaPipe.prototype.numberWithCommas = function (x) {
            var _a;
            return (_a = x === null || x === void 0 ? void 0 : x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',')) !== null && _a !== void 0 ? _a : '';
        };
        SeparateThreeCommaPipe.prototype.transform = function (value) {
            if (value != null) {
                return this.numberWithCommas(value);
            }
            return '0';
        };
        return SeparateThreeCommaPipe;
    }());
    SeparateThreeCommaPipe.ɵprov = i0.ɵɵdefineInjectable({ factory: function SeparateThreeCommaPipe_Factory() { return new SeparateThreeCommaPipe(); }, token: SeparateThreeCommaPipe, providedIn: "root" });
    SeparateThreeCommaPipe.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] },
        { type: i0.Pipe, args: [{
                    name: 'separateThreeComma'
                },] }
    ];

    // import {NGX_MAT_SELECT_CONFIGS} from "";
    var ngxMatSelectConfigs = {
        emptyLabel: 'موردی یافت نشد.',
        searchBoxPlaceholder: 'جستوجو'
    };
    var NgxMatFiltersModule = /** @class */ (function () {
        function NgxMatFiltersModule() {
        }
        NgxMatFiltersModule.forChild = function () {
            return {
                ngModule: ngxFilters.NgxFiltersModule
            };
        };
        NgxMatFiltersModule.forRoot = function (configs, ngxMatSelectConfig) {
            var defaultConfigs = {
                dateComponent: DateTimeFilterComponent,
                conditionSelectorComponent: MatConditionsSelectorComponent,
                multiSelectBoxComponent: MultiSelectBoxFilterComponent,
                numberBoxComponent: NumberBoxFilterComponent,
                selectBoxComponent: SelectBoxFilterComponent,
                textBoxComponent: TextBoxFilterComponent,
                trueFalseComponent: TrueFalseFilterComponent,
                translator: new ngxFilters.FilterTranslator()
            };
            var c = Object.assign(defaultConfigs, configs);
            if (ngxMatSelectConfig) {
                return {
                    ngModule: ngxFilters.NgxFiltersModule,
                    providers: [
                        { provide: ngxMatSelect.NGX_MAT_SELECT_CONFIGS, useValue: ngxMatSelectConfig },
                        ngxFilters.NgxFiltersService,
                        {
                            provide: ngxFilters.NGX_FILTERS_CONFIGS, useValue: c
                        },
                    ]
                };
            }
            else {
                return {
                    ngModule: ngxFilters.NgxFiltersModule,
                    providers: [
                        ngxFilters.NgxFiltersService,
                        {
                            provide: ngxFilters.NGX_FILTERS_CONFIGS, useValue: c
                        },
                    ]
                };
            }
        };
        return NgxMatFiltersModule;
    }());
    NgxMatFiltersModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [
                        MatConditionsSelectorComponent,
                        DateTimeFilterComponent,
                        NumberBoxFilterComponent,
                        SelectBoxFilterComponent,
                        TextBoxFilterComponent,
                        TrueFalseFilterComponent,
                        MultiSelectBoxFilterComponent,
                        TrueFalseFilterPipe,
                        SeparateThreeCommaPipe
                    ],
                    imports: [
                        common.CommonModule,
                        select.MatSelectModule,
                        dialog.MatDialogModule,
                        formField.MatFormFieldModule,
                        input.MatInputModule,
                        forms.FormsModule,
                        datepicker.MatDatepickerModule,
                        slideToggle.MatSlideToggleModule,
                        ngxMatSelect.NgxMatSelectModule,
                    ],
                    providers: [],
                    exports: [
                        select.MatSelectModule,
                        dialog.MatDialogModule,
                        datepicker.MatDatepickerModule
                    ],
                },] }
    ];

    /*
     * Public API Surface of ngx-mat-filters
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.DateTimeFilterComponent = DateTimeFilterComponent;
    exports.MatConditionsSelectorComponent = MatConditionsSelectorComponent;
    exports.MatSelectBase = MatSelectBase;
    exports.MultiSelectBoxFilterComponent = MultiSelectBoxFilterComponent;
    exports.NgxMatFiltersModule = NgxMatFiltersModule;
    exports.NumberBoxFilterComponent = NumberBoxFilterComponent;
    exports.SelectBoxFilterComponent = SelectBoxFilterComponent;
    exports.TextBoxFilterComponent = TextBoxFilterComponent;
    exports.TrueFalseFilterComponent = TrueFalseFilterComponent;
    exports.TrueFalseFilterPipe = TrueFalseFilterPipe;
    exports.ngxMatSelectConfigs = ngxMatSelectConfigs;
    exports.ɵa = SeparateThreeCommaPipe;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-mat-filters.umd.js.map
