import { NgxMatSelectConfigs, NgxMatSelectDirective } from "ngx-mat-select";
import { Filter, NgxSelectBoxFilter } from "ngx-filters";
import { EventEmitter, Injector } from "@angular/core";
export declare abstract class MatSelectBase extends NgxSelectBoxFilter {
    abstract filter: Filter;
    abstract label: string;
    abstract options: any;
    abstract value: any;
    abstract valueChange: EventEmitter<any>;
    sf: NgxMatSelectDirective;
    selectBoxConfigs: NgxMatSelectConfigs;
    constructor(injector: Injector);
    ngAfterViewInit(): void;
    ngOnInit(): void;
}
